<script lang="ts">
import Vue, { PropType } from "vue";
import { SlpButton, SlpTypography, SlpIcon } from "slippers-ui";

interface item {
  href: string;
  text: string;
  headerGa: Object;
}

export default Vue.extend({
  components: {
    SlpButton,
    SlpTypography,
    SlpIcon,
  },
  props: {
    title: {
      type: String,
      required: false,
    },
    icon: {
      type: String,
      required: false,
    },
    href: {
      type: String,
      required: false,
    },
    description: {
      type: String,
      required: false,
    },
    items: {
      type: Array as PropType<item[]>,
      required: false,
    },
    ctaText: {
      type: String,
      required: false,
    },
    disableLineBreaks: {
      type: Boolean,
      required: false,
      default: false,
    },
    headerGa: {
      type: Object,
      required: false,
    },
  },
  computed: {
    updatedTitle() {
      return this.disableLineBreaks
        ? this.title.replace(/<\/?[^>]+(>|$)/g, "")
        : this.title;
    },
  },
});
</script>

<template>
  <component
    :is="ctaText ? 'a' : 'div'"
    v-bind="ctaText ? headerGa : {}"
    :href="href"
    :class="{ 'anchor-wrapper': ctaText }"
  >
    <div class="nav-card">
      <SlpIcon v-if="icon" :name="icon" variant="marketing" size="24" />
      <SlpTypography
        variant="body1-bold"
        tag="a"
        :href="href"
        v-bind="headerGa"
        class="title"
        :class="{ link: !ctaText }"
      >
        <span v-html="updatedTitle"></span>
        <SlpIcon
          v-if="icon"
          class="slp-ml-8 title-chevron"
          name="chevron-lg-right"
          variant="product"
          alt="Chevron Right Icon"
        />
      </SlpTypography>
      <SlpTypography variant="body3" class="description">
        {{ description }}
      </SlpTypography>
      <div class="items" v-if="items.length">
        <SlpTypography
          variant="body2-bold"
          class="item link"
          tag="a"
          :href="item.href"
          v-bind="item.headerGa"
          v-for="item in items"
          :key="item.text"
        >
          {{ item.text }}
        </SlpTypography>
      </div>
      <SlpTypography
        v-if="ctaText"
        variant="body3-bold"
        tag="a"
        :href="href"
        v-bind="headerGa"
        class="nav-card__link"
      >
        {{ ctaText }}
        <SlpIcon
          class="slp-ml-4 cta-chevron"
          name="chevron-lg-right"
          variant="product"
          alt="Chevron Right Icon"
        />
      </SlpTypography>
    </div>
  </component>
</template>

<style lang="scss" scoped>
.nav-card {
  display: flex;
  height: 100%;
  padding: 24px;
  align-items: flex-start;
  gap: 16px;
  flex-direction: column;
  background: white;
  .title {
    display: flex;
    flex-wrap: nowrap;
    align-items: center;
    color: black;
    &:hover {
      .title-chevron {
        visibility: visible;
      }
    }
  }
  .title,
  .description,
  .items {
    white-space: normal;
  }
  .nav-card__link {
    color: #000;
    display: inline-flex;
    align-items: center;
    text-decoration: underline;
    text-decoration-color: transparent;
    text-underline-offset: 2px;
    transition: all 0.3s ease;
    .slp-icon {
      height: 12px !important;
      width: 12px !important;
      position: relative;
      transition: all 0.3s ease;
      transform: translateX(0);
      &:deep(svg) {
        left: 0;
        position: absolute;
        top: 0;
      }
    }
  }
  &:hover,
  &:focus {
    .nav-card__link {
      text-decoration-color: #000;

      .slp-icon {
        transform: translateX(8px);
      }
    }
  }
}
.anchor-wrapper {
  &:hover {
    .cta,
    .link {
      color: $color-text-link-100;
    }
  }
}
.description {
  color: rgba(116, 113, 122, 0.75);
}
.items {
  display: flex;
  margin-top: 4px;
  align-items: flex-start;
  gap: 16px;
  flex-direction: column;
  @media (max-width: $breakpoint-lg) {
    padding-left: 16px;
    width: 100%;
    .item {
      border-bottom: 1px solid $color-surface-300;
      width: 100%;
      padding-bottom: 16px;
    }
    .link {
      color: $color-text-300;
      font-weight: 400;
    }
  }
}

.link {
  color: black;
  &:hover {
    color: $color-text-link-100;
  }
}

.cta {
  display: flex;
  align-items: center;
}

.title-chevron {
  align-self: flex-end;
  padding-bottom: 25px;
  visibility: hidden;
  @media (max-width: $breakpoint-lg) {
    visibility: visible;
  }
}
</style>
